import pyNN.spiNNaker as sim
import cPickle as pickle

def printPklSpikes(fileName):
    fileHandle = open(fileName)
    neoObj = pickle.load(fileHandle)
    segments = neoObj.segments
    segment = segments[0]
    spikeTrains = segment.spiketrains
    neurons = len(spikeTrains)
    for neuronNum in range (0,neurons):
        if (len(spikeTrains[neuronNum])>0):
            spikes = spikeTrains[neuronNum]
            for spike in range (0,len(spikes)):
                print neuronNum, spikes[spike]
    fileHandle.close()
    

def printSpikes(neurons):
    print 'print spikes'
    spike_counts = neurons.get_spike_counts()
    print spike_counts

sim.setup(timestep=1.0)

print 'chrisStart'

cells = sim.Population(10,sim.IF_cond_exp,{})
cells.record({'spikes','v'})

inputSpikeTimes0 = [10.0]
spikeArray0 = {'spike_times': [inputSpikeTimes0]}
spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')

connectorList = [(0,1,1.0,1.0)]
connList = sim.FromListConnector(connectorList)

SYNAPSE_PARAMS = {}
staticSynapse = sim.StaticSynapse(**SYNAPSE_PARAMS)

sim.Projection(presynaptic_population=spikeGen0, postsynaptic_population=cells,
               connector=connList, synapse_type=staticSynapse, receptor_type='excitatory')

#sim.Projection(spikeGen0, cells,connList, staticSynapse)

sim.run(100.0)

#printSpikes(cells)
#cells.printSpikes('temp.pkl') doesn't work on collab
cells.write_data('temp.pkl','spikes')
printPklSpikes('temp.pkl')

print 'chrisEnd'
